const logger = require('@pubsweet/logger')
const helpers = require('../../helpers/helpers')
const emailHelper = require('../../helpers/Email')

module.exports = models => async (req, res) => {
  const { email, type, role } = req.body
  if (!helpers.checkForUndefinedParams(email, type, role)) {
    res.status(400).json({ error: 'Email and type are required.' })
    logger.error('User ID and role are missing')
    return
  }

  if (type !== 'invite')
    return res.status(400).json({ error: `Email type ${type} is not defined.` })

  return emailHelper.setupNewUserEmail({
    dashboardUrl: `${req.protocol}://${req.get('host')}`,
    res,
    email,
    role,
    UserModel: models.User,
  })
}
